{
  "openapi": "3.2.0",
  "info": {
    "version": "2.1.0",
    "title": "Sinch Engage",
    "termsOfService": "https://www.sinch.com/legal/terms-and-conditions/",
    "contact": {
      "name": "Sinch Engage Support",
      "email": "support@app.sinch.com",
      "url": "https://support.app.sinch.com/hc/en-us/categories/10516535548943-Sinch-Engage-Developer-Guides"
    },
    "license": {
      "name": "Apache 2.0",
      "url": "https://www.apache.org/licenses/LICENSE-2.0.html"
    },
    "x-logo": {
      "url": "./logo.png"
    },
    "description": "# Introduction\nThe Sinch APIs provide powerful business messaging capabilities across sending, receiving, and processing SMS, MMS, and rich messaging. \n\nAll requests to the Sinch REST API must be authenticated, this can either be done using Basic Authentication or by signing with a HMAC signature.\n\n\n\n# Base URI\n  \nThe API uses the following base URI\n\nFor EU instance please use https://eu.app.api.sinch.com\n\nFor APAC instance, use https://au.app.api.sinch.com\n\n# Credentials\n  \nTo access the API, an API key and secret are required.\n  \n[Sign up for a developer account here to get access](https://support.app.sinch.com/hc/en-us/categories/10516535548943-Sinch-Engage-Developer-Guides)\n\n# Features\n###  De-Duplication \nDe-Duplication helps you avoid having to undertake data cleansing before commencing send outs.  \nIt automatically detects and withholds messages deemed to be duplicates through the use of a 24-hour window – if a message is sent to the same number with the same content within a 24hr period, the subsequent message(s) will be withheld and rejected. To enable this, you don't need to make any changes to your application, just an account configuration change by Sinch's support team.\n\n###  Social Sending \nSocial Sending permits messages to be sent only during sociable hours - i.e. 8am to 6pm (based on your accounts local time zone - not local time). \nMessages sent outside of these hours are scheduled to be released during the next social time period. This feature helps businesses avoid send-outs during a time that would be deemed unsuitable by the customer. To enable this, you don't need to make any changes to your application, just an account configuration change by Sinch's support team.\n\n###  Familiar Sender\nFamiliar Sender ensures all communication sent to a customer are from the same phone number. \nThis allows businesses to build trust and familiarity with their customers and not confuse them by changing outgoing numbers. To enable this, you don't need to make any changes to your application, just an account configuration change by Sinch's support team.\n\n### Character Converter\nCharacters in a message may not always fall within the GSM-7 supported character set, and when this occurs all \noutbound messages will be encoded using UCS-2 leading to the customer being double-charged for the SMS. Character Converter \ncan help you avoid being double-charged for your SMS by converting all characters into the GSM-7 format ensuring you always \nget the maximum characters into an SMS. Bear in mind, this will downgrade all your unicode characters so for instance, \nyour emojis will be translated into a string of unknown characters (eg: �).  To enable this, you don't need to make any \nchanges to your application, just an account configuration change by Sinch's support team.\n"
  },
  "servers": [
    {
      "url": "https://eu.app.api.sinch.com/",
      "description": "EU instance",
      "name": "EU"
    },
    {
      "url": "https://au.app.api.sinch.com/",
      "description": "APAC instance",
      "name": "APAC"
    }
  ],
  "tags": [
    {
      "name": "Basic Authentication",
      "kind": "nav",
      "description": "\nEvery request requires an `Authorization` header in the following format:\n```plain\nAuthorization: Basic Base64(api_key:api_secret)\n```\nWhere the header consists of the Basic keyword followed by your Basic Authentication `api_key` and `api_secret` that you have been supplied by support, separated with a colon (:) which is then Base64 encoded.\n### Example request with Basic Authentication\n```plain\nPOST /v1/messages HTTP/1.1\nHost: eu.app.api.sinch.com\nAccept: application/json\nContent-Type: application/json\nAuthorization: Basic dGhpc2lzYWtleTp0aGlzaXNhc2VjcmV0Zm9ybW1iYXNpY2F1dGhyZXN0YXBp\n{\n  \"messages\": [\n    {\n      \"content\": \"Hello World\",\n      \"destination_number\": \"+61491570156\",\n      \"format\": \"SMS\"\n    }\n  ]\n} \n```\n_Note: spaces are used as indentation in the body of the above request._"
    },
    {
      "name": "HMAC Authentication",
      "kind": "nav",
      "description": "\nEvery request requires an `Authorization` header in the following formats:\nFor a request with a request body:\n```plain\nAuthorization: hmac username=\"<API KEY>\", algorithm=\"hmac-sha256\", headers  =\"Date Content-MD5 request-line\", signature=\"<SIGNATURE>\"\n```\n\nFor a request _without_ a request body:\n\n```plain\nAuthorization: hmac username=\"<API KEY>\", algorithm=\"hmac-sha256\", headers=\"Date request-line\", signature=\"<SIGNATURE>\"\n```\n### To create this header\n#### Step 1\nAdd a `Date` header to the request using the current date time in [RFC7231 Section 7.1.1.2](http://tools.ietf.org/html/rfc7231#section-7.1.1.2) format\n#### Step 2\nIf the request has a body, add a header called `Content-MD5` where the value of this header is an MD5 hash of the request body, otherwise this header is not required\n#### Step 3\nCreate a signing string by concatenating the `Date` header, the\n`Content-MD5` header (if set) and the request line with line breaks:\n```plain\nDate: Sat, 30 Jul 2016 05:13:23 GMT\\nContent-MD5: 10fd4feab20d38432480c07301e49616\\nPOST /v1/messages HTTP/1.1\n```\nor\n```plain\nDate: Sat, 30 Jul 2016 05:13:23 GMT\\nGET /v1/messages/404b941b-2a29-469f-b114-9ea3e16bbe18 HTTP/1.1\n```\n#### Step 4\nCreate a SHA256 HMAC hash using the signing string and the secret key (both converted to bytes using UTF-8) ```HMAC-SHA256(signing string, secret)```\n#### Step 5\nBase64 encode the HMAC hash and include it as the signature in the ```Authorization``` header\n### Example request with body\n```plain\nPOST /v1/messages HTTP/1.1\nHost: eu.app.api.sinch.com\nAccept: application/json\nContent-Type: application/json\nDate: Sat, 30 Jul 2016 05:18:52 GMT\nAuthorization: hmac username=\"uCXUdoogNfCsehEClbO2\", algorithm=\"hmac-sha256\", headers=\"Date Content-MD5 request-line\", signature=\"Ia4G5lkhH/3NDYpix+8ZHUnp6bA=\"\nContent-MD5: 5407644fa83bec240dede971307e0cad\nContent-Length: 133\n{\n  \"messages\": [\n    {\n      \"content\": \"Hello World\",\n      \"destination_number\": \"+61491570156\",\n    \"format\": \"SMS\"\n    }\n  ]\n}\n```\n_Note: spaces are used as indentation in the body of the above request._\n### Example request without body\n```plain\nGET /v1/messages/404b941b-2a29-469f-b114-9ea3e16bbe18 HTTP/1.1\nHost: eu.app.api.sinch.com\nAccept: application/json\nDate: Sat, 30 Jul 2016 05:18:52 GMT\nAuthorization: hmac username=\"uCXUdoogNfCsehEClbO2\", algorithm=\"hmac-sha256\", headers=\"Date request-line\", signature=\"NTUwMjUwNTVmZGYzZTIxODMyYjc1ZmM3M2EwZWQ1NzA3NzA4ZTZjNw==\" ```"
    },
    {
      "name": "Sub-accounts",
      "kind": "nav",
      "description": "## Performing actions on behalf of sub-accounts\nUsing API keys at the parent account level, you can perform actions on behalf of a sub-account. \n\nThis feature is supported by the Messages, Replies, Delivery Reports and Webhooks APIs. \n\nTo do this\n  include a header key ```Account``` with the sub-account ID as the value. For example:\n  ```Account: mySubAccount```\n\n  **Example request with Sending from sub-accounts**\n\n  ```plain\n  POST /v1/messages HTTP/1.1\n  Host: eu.app.api.sinch.com\n  Accept: application/json\n  Content-Type: application/json\n  Authorization: Basic dGhpc2lzYWtleTp0aGlzaXNhc2VjcmV0Zm9ybW1iYXNpY2F1dGhyZXN0YXBp\n  Account: SubAccount\n  {\n    \"messages\": [\n      {\n        \"content\": \"Hello World\",\n        \"destination_number\": \"+61491570156\",\n        \"delivery_report\": true\n      }\n    ]\n  } \n  ```\n"
    },
    {
      "name": "Messages",
      "description": "The Sinch Messages API provides a number of endpoints for building powerful two-way messaging applications. The Messages API provides access to three main resources:\n* Messages - Messages delivered from an application to a handset.\n* Delivery Reports - Real time reports on the delivery status of a message. As a message is processed, it's status may change several times before it is finally delivered to a handset.\n* Replies - Messages sent from a handset to an application. These messages are typically a reply to a previously sent message.\n![Message Flow](./message-flow.png)"
    },
    {
      "name": "Source Address",
      "description": "The source address API provides several endpoints for you to request an SMS sender ID and track its approval status.\n\n**What is Trusted Sender ID?**\n\nSimply put, a sender ID is whatever you send a text message from. This is typically either a phone number, or a string of alphanumeric characters (commonly referred to as an \"Alpha Tag\").\n\nWith regulations surrounding SMS becoming much stricter all over the world in an effect to combat scam SMS messages, Sinch is working on \"Trusted Sender ID\" a concept that allows customers to request a Sender ID and have it verified.\n\nCurrently, Trusted Sender ID supports two types of Sender ID: Alpha Tags and Personal (\"Own\") Numbers. It will likely be extended to support additional number types, such as TFN and 10DLC where additional registration, (external) verification, and overall account allowlist of numbers will be required.\n\n### Alpha Tag\n  Sending messages from your brand name is particularly ideal for SMS marketing and two-factor authentication, as it increases recognition and trust. There are, however, a few considerations to be aware of. \n  \n  Alpha tags are made up of 3-11 letters and/or numbers. Alpha tags must be registered and approved before sending and must have clear relevancy to your business and/or use case.\n  \n  Alpha Tags appear as the \"From\" number when you receive messages.\n  \n  A good alpha tag meets at least one of the following valid use cases: \n  * Business names\n  * Trademark names    \n  * Product or service name\n  * an acronym, initialism, or contraction of your entity\n  \n  In addition to the requirements around clearly relating to the business, we typically advise the following for alpha tags to ensure maximum compatibility with the various carriers:\n  * 6-11 characters long\n  * Only contains characters from the following sets:\n  * A-Z\n  * a-z\n  * 0-9\n  * _ (underscore)\n  * \\- (hyphen)\n  \n  Alpha Tags can currently be registered through the Source Address API for the following countries: ```AD```, ```AI```, ```AL```, ```AS```, ```AT```, ```AU```, ```AW```, ```BA```, ```BB```, ```BH```, ```BW```, ```CD```, ```CH```, ```CK```, ```CY```, ```DE```, ```DJ```, ```DK```, ```DM```, ```EE```, ```ES```, ```FI```, ```FJ```, ```FM```, ```FO```, ```FR```, ```GB```, ```GD```, ```GG```, ```GI```, ```GL```, ```GM```, ```GQ```, ```GR```, ```GY```, ```IL```, ```IM```, ```IS```, ```JE```, ```JM```, ```JP```, ```KI```, ```KY```, ```LA```, ```LI```, ```LS```, ```LT```, ```LU```, ```LV```, ```MC```, ```ME```, ```MH```, ```MO```, ```MR```, ```MS```, ```MT```, ```MV```, ```NC```, ```NF```, ```NL```, ```NO```, ```NR```, ```NU```, ```PF```, ```PM```, ```PT```, ```SB```, ```SC```, ```SE```, ```SH```, ```SL```, ```SM```, ```ST```, ```TC```, ```TD```, ```TO```, ```VC```, ```VG``` and ```WS```\n  \n  To register an Alpha Tag as a sender ID you must:\n  1. Make a request to the **Request a Sender Address** endpoint\n  2. Wait for the alpha tag to be approved. The status of the alpha tag can be monitored using the **Get status of a sender address request** endpoint\n  \n  Once the alpha tag has been approved, you can begin using it as a Sender ID for SMS messages.\n\n  ### Personal Number\n  A personal number, or \"My Own Number\", is a number that you own rather than one provided to you by Sinch. Typically, this is your personal mobile phone number. You may wish to register this number for use with our service so that you can easily send messages from a number already associated with your organisation.\n  \n  Before you can send messages using your own number, you need to verify that you have a right to use that number. Ensuring you have a right to use a phone number is an important regulatory requirement, aiming to prevent scam, spam, and misuse of messaging services.\n\n  Personal numbers can currently be registered through the Source Address API for the following countries: ```AT```, ```AU```, ```CH```, ```CY```, ```DE```, ```DK```, ```EE```, ```ES```, ```FI```, ```GB```, ```HR```, ```IE```, ```IT```, ```LT```, ```LU```, ```LV```, ```MT```, ```NL```, ```NO```, ```PT```, ```SE```, and ```SI```\n\n  To register a personal number as a Sender ID you must:\n  1. Make a request to the **Request a Sender Address** endpoint\n  2. A unique verification code will be sent to the requested number\n  3. Make a request to the **Submitting a Verification Code** endpoint, using the verification code that was sent in the previous step. A 200 OK response will indicate the number has been verified and is ready for use.\n\n  ⚠️ Own numbers need to be re-verified every 12 months. You will be notified by email that verification of your number is about to expire.\n\n  ### Requesting a Source Address on behalf of a sub-account\n  By default, all requests made through the API are made on behalf of the account that the API keys used to authorize the request were made on. API keys created on a parent account can request a source address on behalf of a sub-account. To do this, include a header key ```Account``` with the sub-account ID as the value. For example: \n  ```Account: mySubAccount```\n\n  **Example request with Request a Sender Address from a sub-account**\n  ```plain\n  POST /v1/messaging/numbers/sender_address/requests HTTP/1.1\n  Host: eu.app.api.sinch.com\n  Accept: application/json\n  Content-Type: application/json\n  Authorization: Basic dGhpc2lzYWtleTp0aGlzaXNhc2VjcmV0Zm9ybW1iYXNpY2F1dGhyZXN0YXBp\n  Account: mySubAccount\n  {\n    \"sender_address\": \"+61341234131\",\n    \"sender_address_type\": \"INTERNATIONAL\",\n    \"usage_type\": \"OWN_NUMBER\",\n    \"destination_countries\": [\n        \"AU\"\n    ],\n    \"reason\": \"I confirm that my business has a valid use case\",\n    \"label\": \"my number sample\"\n  } \n  ```\n  *Note: The use of the Account header key applies to all Source Address endpoints.*\n"
    },
    {
      "name": "Delivery Reports",
      "description": "If a callback URL is specified in the submit message request, then changes to the message status, \nreplies received in response to the message or delivery reports received for the message will be pushed via a HTTP POST request. An alternative to delivery reports via a callback URL is custom webhooks using the webhooks management API. \n\nAll notifications are JSON encoded and the request expects to receive a response in the HTTP 200 range. If a valid response isn't received the request will be retried in an exponentially backing off fashion.\n\nDelivery Reports may carry an additional charge. For pricing, please contact your Account Manager or Support Team (<support@app.sinch.com>).\n\nTo include billing units in your delivery receipts via Webhooks, ensure that the switch \"Enable billing units in Delivery Reports and Callbacks\" is enabled in the API settings of your account.\n\nFor delivery reports or changes in the status of a message, the POST request to the specified URL will be as follows:\n  \n  _Note, multiple delivery report notifications will be received for a single message._\n\n```javascript\n{\n  \"callback_url\":\"http://mockbin.org/bin/ac52ebd4-eca1-4c86-bf38-4dce79633906\",\n  \"delivery_report_id\":\"693e87f2-a553-4281-9ffe-ddf04cbc4bf3\",\n  \"source_number\":\"+61491570156\",\n  \"date_received\":\"2016-11-03T11:49:02.807Z\",\n  \"status\":\"delivered\",\n  \"delay\":0,\n  \"billing_units\":1,\n  \"submitted_date\":\"2016-11-03T11:49:01.551Z\",\n  \"original_text\":\"Hello world!\",\n  \"message_id\":\"389dc1a8-62a4-4110-ba61-af94806c006f\",\n  \"vendor_account_id\":{\n    \"vendor_id\":\"SinchEU\",\n    \"account_id\":\"MyAccount\"\n  },\n  \"error_code\":\"220\",\n  \"metadata\":{\n    \"key\":\"value\"\n  }\n}\n```\n\n\nThe properties included in the notification are as follows:\n\n* **Callback URL**: The URL specified as the callback URL in the original submit message request.\n\n* **Delivery Report ID**: A unique ID for the delivery report that this notification represents.\n\n* **Source Number**: The destination address of the original message.\n\n* **Date Received**: The date and time at which this notification was generated in UTC.\n\n* **Status**: The status of the message as indicated by this delivery report. The status field can be one of the following values:\n\n  * `enroute`: Message has been received by the gateway and is being processed (or waiting to be processed).\n\n  * `submitted`: Message has been submitted to a provider/carrier for delivery.\n\n  * `delivered`: Message delivery has been confirmed by the provider, including to the handset (where possible).\n\n  * `expired`: The message has expired.\n\n  * `rejected`: The message will not be delivered - permanent failure. Reasons may include usage limit exceeded, insufficient credit, number blocked, or content filtered\n\n  * `failed`: The message has failed. Reasons may include no active routes to destination or undeliverable by downstream provider.\n\n* **Delay**: _Deprecated, no longer in use_\n\n* **Billing Units**: The number of billing units charged for the message.\n\n* **Submitted Date**: Date time status of the message changed in UTC. For a delivered DR this may indicate the time at which the message was received on the handset.\n\n* **Original Text**: Text of the original message.\n\n* **Message ID**: ID of the original message.\n\n* **Vendor Account ID**: The account used to submit the original message. The vendor will always be `SinchEU`\n\n* **Error Code**: A status code which provides additional information about the message status:\n\n  * `101`: Message being processed by the gateway.\n  \n  * `102`: Message is being rerouted to a different provider after failing via the first provider.\n  \n  * `151`: Message held for screening.\n  \n  * `200`: Message submitted to downstream provider for delivery.\n  \n  * `210`: Message accepted by downstream provider.\n  \n  * `211`: Message is enroute for delivery by provider.\n  \n  * `212`: Message submitted. Delivery pending.\n  \n  * `213`: Message scheduled for delivery by downstream provider.\n  \n  * `220`: Message delivered.\n  \n  * `221`: Message delivered to the handset.\n  \n  * `320`: Message validity period has expired (prior to submission).\n  \n  * `401`: Message validity period has expired (before delivery).\n  \n  * `301`: Usage threshold reached. Message discarded.\n  \n  * `302`: Destination address blocked. Message discarded.\n  \n  * `303`: Source address blocked. Message discarded.\n  \n  * `304`: Message dropped. Contact support.\n  \n  * `305`: Message discarded due to duplicate detection.\n  \n  * `402`: Message rejected by downstream provider.\n  \n  * `403`: Message skipped by downstream provider.\n  \n  * `410`: Invalid source address.\n  \n  * `411`: Invalid destination address.\n  \n  * `412`: Destination address blocked.\n  \n  * `413`: SMS service unavailable on destination.\n  \n  * `414`: Destination unreachable.\n  \n  * `330`: Gateway failure.\n  \n  * `331`: Message discarded.\n  \n  * `332`: No available route to destination.\n  \n  * `333`: Source address unsupported for this destination.\n  \n  * `400`: Message failed; undeliverable.\n  \n  * `405`: Message cancelled or deleted by provider.\n"
    },
    {
      "name": "Replies",
      "description": "Endpoints for checking and confirming inbound message replies (MO) received by your account."
    },
    {
      "name": "Number Authorisation",
      "description": "The number authorisation API allows you to manage your blacklists. Sinch automatically adds numbers to your blacklist if people send one of the opt-out keywords in response to one of your messages.\nThis is a legal requirement. If you decide to handle the legal compliance yourself, calls to this endpoint will not affect your messages."
    },
    {
      "name": "Dedicated Numbers",
      "description": "The Numbers API allows your to purchase, provision and configure the dedicated numbers assigned to your Sinch account. \n\nTo learn more about the benefits of dedicated numbers, and their use cases, visit our [feature page](https://support.app.sinch.com/hc/en-us/articles/10526389880207-Dedicated-numbers).\n\nThis is a paid feature and must be enabled on your account. Please contact [support@app.sinch.com](mailto:support@app.sinch.com) or your account manager.\n\n## Concepts\n\nThis API allows you to purchase and assign to your account a number from a pool of dedicated numbers. Dedicated numbers are priced differently according to their classification.\n\nThe following is the system by which we classify dedicated numbers. \n\n| Pattern Type | Gold|  Silver |\n|---|---|---|\n| Same Number  |  Six of same (e.g. 999999) | Five of same (e.g. 999991 or 199999)  | \n| Sequence  |  Six in sequence (e.g. 234567, or 765432) | Five in sequence (e.g. 245678, 456782, or 287654)  |\n|  Triplets |  Two identical (e.g. 123123) or two double (e.g. 444666) | Identical pairs within triplets (e.g. 004008, or 400800), one identical and one in sequence (e.g. 444789, or 345777), or mirror image (e.g. 468864)| \n|Pair|Three identical (e.g. 454545)|Three non-identical (e.g. 447700) or three in sequence (e.g. 232425, or 090807)|\n\nAny numbers that do not meet the criteria for Gold or Silver are classified as Bronze.\n\nFor pricing on dedicated numbers please refer to the Numbers page in our Hub web portal, or speak with your Sinch Account Manager.\n"
    },
    {
      "name": "Messaging Reports",
      "description": "The Sinch Reports API provides a number of endpoints for running reports of messages sent and received through\na Sinch Account. The API allows two kinds of reports, _Detailed Reports_ and _Summary Reports_.\n\nDetailed reports list all messages and the details of each message sent or received in a specified time period. Summary reports allow inbound and outbound message data to be aggregated on a number of dimensions.\n"
    },
    {
      "name": "Short Trackable Links Reports",
      "description": "Short Trackable Links is a feature available to [Messaging API](https://support.app.sinch.com/hc/en-us/categories/10516535548943-Sinch-Engage-Developer-Guides) users whereby it automatically and seamlessly shortens any URL to just 22 characters. Every shortened URL is unique to each recipient.\n\nThe reporting API has endpoints specific to \nthis feature, allowing users to obtain details regarding \nthe number of click-throughs on each URL.\n\nTo enable this feature on your account, contact your account manager or contact support on [support@app.sinch.com](mailto:support@app.sinch.com).\n\nTo learn more about the benefits of the Short Trackable Links feature, [visit our feature page](https://support.app.sinch.com/hc/en-us/articles/10525004171919-Short-Trackable-Links-URL-shortener).\n"
    },
    {
      "name": "Webhooks Management",
      "description": "Webhooks Management API allows you to manage your webhooks configuration. You can subscribe to one or several events, retrieve the webhooks, update them or even delete them if needed."
    },
    {
      "name": "Signature Key Management",
      "description": "As a Sinch customer, you want to be able to ensure that webhooks are coming from Sinch and not from a 3rd party. Since \nthese are calls to your own system, you should be provided with an extra level of security \nwhen calling your resources.\n\nThe Sinch Signature Key API provides a number of endpoints \nfor managing key used to sign each unique request to ensure security \nand the requests can't (easily) be spoofed. This is similar to using \nHMAC in your outbound messaging (rather than HTTP Basic).\n\nThe Signature Key API provides seven main endpoints:\n- ```Create signature key``` Create a new signature key for signature verification in webhooks.\n- ```Get signature key detail``` Retrieve the current detail of a signature key using the key_id returned in the ```create signature key``` endpoint.\n- ```Delete signature key``` Delete a signature key using the key_id returned in the ```create signature key``` endpoint.\n- ```Get signature key list``` Retrieve the paginated list of signature keys.\n- ```Enable signature key``` Enable a signature key using the key_id returned in the ```create signature key``` endpoint.\n- ```Get enabled signature key``` Retrieve the current enabled signature key.\n- ```Disable an enabled signature key``` Disable the current enabled signature key.\n"
    },
    {
      "name": "Mobile Landing Pages (beta)",
      "description": "The mobile landing pages (MLP) API provides the facilities to create mobile landing pages and sends them to recipients. This API is currently in beta. \n\n*Note: This API is only available in the APAC region.*\n  \n## Concepts\n\nThe approach to creating mobile landing pages involves creating a _Campaign_ and sending them to one or more _Recipients_.  A campaign consists of the baseline configuration of a mobile landing page and message that will be generated and sent to each recipient.\n\n## Parameters\n\nCampaign and Recipients can contain parameters.  These parameters are used to customise the generated landing page and the message that is to be sent to each user.  Campaign and Recipient parameters are merged to form a complete set when processing a recipient.\n\nWhen resolving parameters sets, Recipient parameters override Campaign parameters with the same name.\n\nParameter names used within the template have an associated type, which will be validated when creating the Campaign or sending it to Recipients.  You are free to define additional parameters for your own uses, such as when specifying the message.\n\nThe SMS message that is to be sent to each user is defined at the Campaign level. \n\nThe message itself can consist of parameter references surrounded in `${...}`, for example:\n\n```Hello ${firstName} ${lastName}, this is your message.```\n\n## Sending Mobile Landing Pages \n\nFrom end to end, sending a Mobile Landing Pages involves the following steps: \n\n### Step 1: Create a campaign\n\nChoose a template from the template catalogue, and work out what you are going to specify for the required parameters for that template. You will then use the `Create new campaign` endpoint to create the campaign. The following example \nspecifies the desired parameters for the template_id and sets up a message template:\n\n```\n{\n    \"template_id\": \"ac895f01-3149-4bf8-a8fe-01d3b8a9ba97\",\n    \"parameters\": {\n      \"pageTitle\": \"The page title\",\n      \"pageText\": \"The body text\",\n      \"imageUrl\": \"https://example.com/image.jpg\",\n      \"secondaryImageUrl\": \"https://www.example.com/optional_secondary_image.jpg\",\n      \"buttonLink\": \"https://example.com/\",\n      \"buttonText\": \"Call to Action Button Text\",\n      \"secondaryButtonLink\": \"https://example.com/optional_secondary_button\",\n      \"secondaryButtonText\": \"Secondary Call to Action Button\"\n    },\n    \"message\": {\n      \"content\": \"Hello ${firstName} ${lastName}, this is the SMS message body\",\n      \"metadata\": {\n        \"key\": \"value\"\n      }\n    }\n}\n```\n\nInside the message content the `{}` curly braces indicate template placeholders. These are the names of the parameters you will need to specify for the message when you send to your recipients.\n\n### Step 2: Send to recipients\n\nUsing the `Send campaign to recipients` endpoint, you can specify the id of your campaign in the path and a array of recipients as the payload. Each recipient will include an E.164 formatted \n(international) phone number, an optional scheduled time, and values of any recipient scoped template parameters you may have created. In the following example the recipients have been scoped with the template parameters above: \n\n```\n{\n  \"recipients\": [\n    {\n      \"number\": \"+6140000000\",\n      \"parameters\": { \"firstName\":\"Joe\", \"lastName\",\"Bloe\" }\n    },\n    {\n      \"number\": \"+6141111111\",\n      \"parameters\": { \"firstName\":\"Jane\", \"lastName\",\"Doe\" }\n    }\n  ]\n}\n```\n\n## Landing Page Store\n\nThe Landing Page Store is used by the Hub portal to store landing page templates that have been configured using the visual interface. This means that you can \noptionally use this data store to programatically send landing pages that have been designed and configured in the hub.\n\nIf you have made a landing page in the hub, use the `Get landing pages` endpoint to find the landing pages you have made, along with the template and parameters that have been configured. \nYou will then need to copy those template and parameters into a campaign. \n\n## Template Parameters\n\nEach template will have different required parameters, shown in the Templates section. The following is a description of the requirements of each parameter when included in a template.\n\n| Parameter | Required | Tyep|Description |\n|------------------|-------------|-----------|-----------|\n| imageBackgroundUrl | Optional - depends on MLP template. |image| Width: 750 pixels, height: 1624 pixels, size: less than 300 kB, type: png, gif, or jpg|\n| barcodeValue | Optional - depends on MLP template. |text| Alphanumeric string. We will use CODE-128 format 1-D barcode. |\n| barcodeDisplayValue | Optional - defaults to true. Otherwise, use false |text| Indicates whether the barcode value is shown below the barcode image|\n| barcodeHeight| Optional| text||\n| barcodeMargin| Optional| text||\n| barcodeWidth| Optional| text||\n| barcodeLineColor|Optional - each template has it's own default value| text|  Indicate the color of bar code. Use a color name(eg. 'red', 'green'), or a hex value(eg. '#F0F8FF') |\n| pageText | |html| For personalisation, use the following format: \"Hi ${firstName}, thanks for visiting…\"|\n| pageTextColor|Optional - each template has it's own default value| text|  Indicate the color of page text. Use a color name(eg. 'red', 'green'), or a hex value(eg. '#F0F8FF') |\n| imageHeaderUrl | Optional - depends on MLP template |image| Width: 750 pixels, height: 375 pixels, size: less than 300 kB, type: png, gif, or jpg.|\n| headline | |text| For personalisation, use the following format: \"Hi ${firstName}, thanks for visiting…\". Specifications: 60 characters or less recommended|\n| headlineColor|Optional - each template has it's own default value| text|  Indicate the color of headline. Use a color name(eg. 'red', 'green'), or a hex value(eg. '#F0F8FF') |\n| pageTitle | |text| HTML page title shown on browser tab. Specifications: 60 characters or less recommended.|\n| imageLogoUrl |Optional |image| Specifications: width: 300 pixels, height: 120 pixels, size: less than 300 kB, type: png, gif, or jpg|\n| logoLink | Optional|url| For personalisation, use the following format: \"https://example.com/?cid=${customerId}\"|\n| primaryButtonLink | |url| For personalisation, use the following format: \"https://example.com/?cid=${customerId}\"|\n| primaryButtonText | |text| For personalisation, use the following format: \"${firstName}, shop now\". Specifications: 36 characters or less recommended |\n| primaryButtonTextColor|Optional - each template has it's own default value| text|  Indicate the color of primary button text. Use a color name(eg. 'red', 'green'), or a hex value(eg. '#F0F8FF') |\n| primaryButtonBackgroundColor|Optional - each template has it's own default value| text|  Indicate the background color of primary button. Use a color name(eg. 'red', 'green'), or a hex value(eg. '#F0F8FF') |\n| secondaryButtonLink | Optional - depends on MLP template |url| For personalisation, use the following format: \"https://example.com/?cid=${customerId}\"|\n| secondaryButtonText | Optional - depends on MLP template |text| For personalisation, use the following format: \"Hi ${firstName}, thanks for visiting…\". Specifications: 36 characters or less recommended |\n| secondaryButtonTextColor|Optional - each template has it's own default value| text|  Indicate the color of the secondary button text. Use a color name(eg. 'red', 'green'), or a hex value(eg. '#F0F8FF') |\n| secondaryButtonBackgroundColor|Optional - each template has it's own default value| text|  Indicate the background color of secondary button. Use a color name(eg. 'red', 'green'), or a hex value(eg. '#F0F8FF') |\n| fontFamilyURL1 | Optional - each template has it's own default value|url| Indicate the url of font family, those font family can be used in other property(eg. `headlineFontFamily`)|\n| fontFamilyURL2 | Optional - each template has it's own default value|url| Indicate the url of font family, those font family can be used in other property(eg. `headlineFontFamily`)|\n| fontFamilyURL3 | Optional - each template has it's own default value|url| Indicate the url of font family, those font family can be used in other property(eg. `headlineFontFamily`)|\n| pageTextFontFamily | |text| Specify the font family of page text |\n| headlineFontFamily | |text| Specify the font family of headline text |\n| buttonFontFamily | |text| Specify the font family of button text |\n\n## Template Catalogue\n\n | Name and preview | Template ID |\n |-------------------|-------------|\n | ![](https://developers.sinch.com/wp-content/templates/Template1.png) | 7614456e-844f-4d83-bdfe-20c17ce0f97c |\n | ![](https://developers.sinch.com/wp-content/templates/Template2.png) | f56b5806-f732-4693-b87a-90b66a7d7bfc |\n |![](https://developers.sinch.com/wp-content/templates/template3.png) | c9d7ce1d-20c4-4228-9ba1-6da2a3b4e5e0 |\n"
    },
    {
      "name": "Contacts",
      "description": "The API provides access to two main resources:\n\n  * **Contacts**: Data associated with the individuals you need to contact.\n  * **Lists**: Groups of contacts created for specific purposes.\n  * **Custom Fields**: Additional fields that can be tailored to complement the basic contact fields.\n"
    }
  ],
  "paths": {
    "/v2-preview/reporting/messages/metakeys": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Metadata Keys",
        "description": "Returns a list of metadata keys.",
        "operationId": "PostMetadataKeys",
        "parameters": [],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/metakeyrequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "A list of metadata keys.",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/metakeyresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request. Check the json response for more details on what went wrong."
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          }
        }
      }
    },
    "/v2-preview/reporting/messages/detail": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Post detail report",
        "description": "Generates a report listing all sent and/or received messages within a specified time period.",
        "operationId": "PostDetailReport",
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/detailrequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "A list of all messages received in the specified time window",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/detailresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/messages/insights": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Post insight report",
        "description": "Create report summary containing total number of sent, received and billing units, using pre-calculated data to improve performance.",
        "operationId": "PostInsightReport",
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/insightsrequest"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "A list of all messages received in the specified time window",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/insightsresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/messages/async/detail": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Post async detail report",
        "description": "Generates an asynchronous report listing all sent and/or received messages within a specified time period.",
        "operationId": "PostAsyncDetailReport",
        "parameters": [],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/asyncsentmessagesdetailrequest"
              }
            }
          },
          "required": true
        },
        "responses": {
          "202": {
            "description": "A list of all messages received in the specified time window",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/asyncreportresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/messages/async/summary": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Post async summary report",
        "description": "Creates an asynchronous report summary containing total number of sent, received and billing units.",
        "operationId": "PostAsyncSummaryReport",
        "parameters": [],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/asyncsummaryrequest"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "A list of all messages received in the specified time window",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/asyncreportresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/messages/async/status": {
      "get": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Get async detail report status",
        "description": "Retrieves the status of a detail report.",
        "operationId": "GetAsyncDetailStatus",
        "parameters": [
          {
            "name": "report_id",
            "in": "query",
            "description": "The ID of the detail report to retrieve.",
            "required": true,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "string",
              "example": "abc"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "The status of the requested detail report.",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/reportstatusresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/messages/async/detail/fields": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Get async detail fields",
        "description": "Can be used for async detail report to select the fields to export csv files",
        "operationId": "GetAsyncDetailFields",
        "parameters": [],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/metakeyrequest"
              },
              "example": {
                "page": 1,
                "page_size": 50,
                "start_date": "2020-05-28T10:27:46.259Z",
                "end_date": "2020-06-28T10:27:46.259Z"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "A list of selected fields to export csv files.",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/fieldsresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/messages/async/reports": {
      "get": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          },
          {
            "bearer_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Get async report history",
        "description": "Returns a list of asynchronous reports that have been requested by the current account.",
        "operationId": "GetAsyncReportHistory",
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "description": "The number of items to return per page.",
            "required": false,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "integer",
              "example": 10
            }
          },
          {
            "name": "page_token",
            "in": "query",
            "description": "A pagination token returned from a previous call. Pass this to retrieve the next page of results.",
            "required": false,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "string",
              "example": "eyJyZXBvcnRJZCI6IjUxZjAwOTdmLTkwYjItNGE1OS1hZDg4LWEwZmQ5M2FiYWE4MiJ9"
            }
          },
          {
            "name": "report_name",
            "in": "query",
            "description": "Filter results by report name.",
            "required": false,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "string",
              "example": "My Detail Report"
            }
          },
          {
            "name": "status",
            "in": "query",
            "description": "Filter results by report status. Multiple statuses can be specified.",
            "required": false,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "enum": [
                  "REQUESTED",
                  "RUNNING",
                  "FAILED",
                  "CANCELLED",
                  "DONE"
                ]
              }
            }
          },
          {
            "name": "start_date",
            "in": "query",
            "description": "Filter reports requested on or after this date (ISO 8601).",
            "required": false,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "string",
              "format": "date-time",
              "example": "2020-05-28T10:27:46.259Z"
            }
          },
          {
            "name": "end_date",
            "in": "query",
            "description": "Filter reports requested on or before this date (ISO 8601).",
            "required": false,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "string",
              "format": "date-time",
              "example": "2020-06-28T10:27:46.259Z"
            }
          },
          {
            "name": "sort_direction",
            "in": "query",
            "description": "Sort direction for the results.",
            "required": false,
            "style": "form",
            "explode": true,
            "schema": {
              "type": "string",
              "enum": [
                "ASCENDING",
                "DESCENDING"
              ],
              "example": "DESCENDING"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "A list of async reports for the current account.",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/reporthistoryresponses"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/messages/async/reports/{reportId}/download-url": {
      "get": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          },
          {
            "bearer_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Get async report download URL",
        "description": "Returns a temporary pre-signed URL for downloading the generated report. The URL allows customers to securely download the report file directly using the provided reportId.",
        "operationId": "GetAsyncReportDownloadUrl",
        "parameters": [
          {
            "name": "reportId",
            "in": "path",
            "description": "The ID of the report to download.",
            "required": true,
            "style": "simple",
            "schema": {
              "type": "string",
              "format": "uuid",
              "example": "51f0097f-90b2-4a59-ad88-a0fd93abaa82"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "A pre-signed URL for downloading the report.",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/presignedurlresponse"
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "404": {
            "description": "Report not found."
          }
        }
      }
    },
    "/v2-preview/reporting/detail/scheduled": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Scheduled detail report",
        "description": "Create scheduled report in detail containing total number of sent, received and billing units.",
        "operationId": "detailscheduledreport",
        "parameters": [],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/scheduleddetailreport"
              }
            }
          },
          "required": true
        },
        "responses": {
          "201": {
            "description": "A scheduled detail report received using the specified parameters.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/scheduledreportresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/detail/scheduled/{scheduled_id}": {
      "put": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Update a scheduled detail report",
        "description": "Updates a selected scheduled report in detail, which contains a total number of sent, received and billing units.",
        "operationId": "updatedetailscheduledreport",
        "parameters": [
          {
            "name": "scheduled_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "The ID of the scheduled report to update.",
            "example": "e6fb8282-c7c3-4367-8590-6c77ddb11c3e"
          }
        ],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/updatescheduleddetailreport"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "The updated scheduled detail report.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/scheduleddetailreportresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/summary/scheduled": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Scheduled summary report",
        "description": "Create scheduled report summary containing total number of sent, received and billing units.",
        "operationId": "summaryscheduledreport",
        "parameters": [],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/scheduledsummaryreport"
              }
            }
          },
          "required": true
        },
        "responses": {
          "201": {
            "description": "A scheduled summary report received using the specified parameters.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/scheduledreportresponse"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/summary/scheduled/{scheduled_id}": {
      "put": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Update a scheduled summary report",
        "description": "Updates a selected scheduled report summary, which contains a total number of sent, received and billing units.",
        "operationId": "updatesummaryscheduledreport",
        "parameters": [
          {
            "name": "scheduled_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "The ID of the scheduled report to update.",
            "example": "e6fb8282-c7c3-4367-8590-6c77ddb11c3e"
          }
        ],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/updatescheduledsummaryreport"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "The updated scheduled summary report.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/scheduledsummaryreportresposne"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        }
      }
    },
    "/v2-preview/reporting/scheduled": {
      "get": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Get active reports",
        "description": "Retrieves all ACTIVE scheduled reports of a provided account.",
        "operationId": "GetActiveReport",
        "parameters": [
          {
            "name": "page_size",
            "in": "query",
            "description": "Number of results to return in a page for paginated result sets.",
            "style": "form",
            "explode": true,
            "schema": {
              "type": "number",
              "example": 20,
              "minimum": 1,
              "maximum": 100
            }
          },
          {
            "name": "page_token",
            "in": "query",
            "description": "Returned by Chronos service",
            "schema": {
              "type": "string",
              "example": "eyJwYWdlIjoyfQ"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "A list of all messages received in the specified time window",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/chronosscheduleresponse"
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "404": {
            "description": "Scheduled report not found."
          }
        }
      }
    },
    "/v2-preview/reporting/scheduled/{scheduled_id}": {
      "get": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Get scheduled report by id",
        "description": "Retrieves a scheduled report by providing its id.",
        "operationId": "GetScheduledReport",
        "parameters": [
          {
            "name": "scheduled_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "The ID of the scheduled report to retrieve.",
            "example": "e6fb8282-c7c3-4367-8590-6c77ddb11c3e"
          }
        ],
        "responses": {
          "200": {
            "description": "The scheduled report matching the provided ID.",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/scheduledreport"
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "404": {
            "description": "Scheduled report not found."
          }
        }
      },
      "delete": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messaging Reports"
        ],
        "summary": "Delete scheduled report by id",
        "description": "Deletes a scheduled report by providing its id.",
        "operationId": "DeleteScheduledReport",
        "parameters": [
          {
            "name": "scheduled_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "description": "The ID of the scheduled report to delete.",
            "example": "e6fb8282-c7c3-4367-8590-6c77ddb11c3e"
          }
        ],
        "responses": {
          "202": {
            "description": "An empty response indicating the report has been deleted."
          },
          "401": {
            "$ref": "#/components/responses/Unauthorized"
          },
          "404": {
            "description": "Scheduled report not found."
          }
        }
      }
    },
    "/v1/messages/{messageId}": {
      "get": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messages"
        ],
        "summary": "Get message status",
        "description": "Retrieve the current status of a message using the message ID returned\nin the send messages endpoint.\n\nA successful request to the get message status endpoint will return a\nresponse body as follows:\n\n```javascript\n\n{\n    \"format\": \"SMS\",\n    \"content\": \"My first message!\",\n    \"metadata\": {\n        \"key1\": \"value1\",\n        \"key2\": \"value2\"\n    },\n    \"message_id\": \"877c19ef-fa2e-4cec-827a-e1df9b5509f7\",\n    \"callback_url\": \"https://my.callback.url.com\",\n    \"delivery_report\": true,\n    \"destination_number\": \"+61401760575\",\n    \"scheduled\": \"2016-11-03T11:49:02.807Z\",\n    \"source_number\": \"+61491570157\",\n    \"source_number_type\": \"INTERNATIONAL\",\n    \"message_expiry_timestamp\": \"2016-11-03T11:49:02.807Z\",\n    \"status\": \"enroute\"\n}\n\n```\n\nThe status property of the response indicates the current status of the\nmessage. See the Delivery Reports section of this documentation for more information on message\nstatuses. The expiry date for getting an entity is 45 days.\n\n*Note: If an invalid or nonexistent message ID parameter is specified\nin the request, then a HTTP 404 Not Found response will be returned*\n",
        "operationId": "GetMessageStatus",
        "parameters": [
          {
            "name": "messageId",
            "in": "path",
            "description": "36 character UUID.",
            "required": true,
            "style": "simple",
            "schema": {
              "type": "string",
              "example": "389dc1a8-62a4-4110-ba61-af94806c006f"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "The submitted message including the status of the message",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Getmessagestatusresponse"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          },
          "404": {
            "description": "Resource not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/404response"
                }
              }
            }
          }
        },
        "x-codeSamples": [
          {
            "lang": "C#",
            "label": "C#",
            "source": "string messageId = \"messageId2\";\n\ntry \n{\n    GetMessageStatusResponse result = messages.GetMessageStatusAsync(messageId).Result;\n}\ncatch (APIException e){};"
          },
          {
            "lang": "Java",
            "label": "Java",
            "source": "String messageId = \"messageId2\";\n\nmessagesController.getMessageStatusAsync(messageId, new APICallBack<GetMessageStatusResponse>() {\n    public void onSuccess(HttpContext context, GetMessageStatusResponse response) {\n        // TODO success callback handler\n    }\n    public void onFailure(HttpContext context, Throwable error) {\n        // TODO failure callback handler\n    }\n});"
          },
          {
            "lang": "JavaScript",
            "label": "JavaScript",
            "source": "let messageId = 'messageId2';\n\nconst promise = controller.getMessageStatus(messageId);\npromise.then((response) => {\n    // this block will be executed on successful endpoint call\n    // `response` will be of type 'GetMessageStatusResponse'\n}, (err) => {\n    // this block will be executed on endpoint call failure\n    // `err` is an 'object' containing more information about the error\n});"
          },
          {
            "lang": "PHP",
            "label": "PHP",
            "source": "$messageId = 'messageId2';\n\n$result = $messagesController->getMessageStatus($messageId);"
          },
          {
            "lang": "Python",
            "label": "Python",
            "source": "message_id = 'messageId2'\n\nresult = messages_controller.get_message_status(message_id)"
          }
        ]
      },
      "put": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messages"
        ],
        "summary": "Cancel scheduled message",
        "description": "Cancel a scheduled message that has not yet been delivered.\n\nA scheduled message can be cancelled by updating the status of a message\nfrom ```scheduled``` to ```cancelled```. This is done by submitting a PUT request to the\nmessages endpoint using the message ID as a parameter (the same endpoint used above to retrieve\nthe status of a message). The expiry date for getting an entity is 45 days.\n\nThe body of the request simply needs to contain a ```status``` property with the value set to ```cancelled```.\n\n```javascript\n\n{\n    \"status\": \"cancelled\"\n}\n\n```\n\n*Note: Only messages with a status of scheduled can be cancelled. If an invalid or nonexistent message ID parameter is specified in the request, then a HTTP 404 Not Found response will be returned*\n",
        "operationId": "CancelScheduledMessage",
        "parameters": [
          {
            "name": "messageId",
            "in": "path",
            "description": "36 character UUID.",
            "required": true,
            "style": "simple",
            "schema": {
              "type": "string",
              "example": "389dc1a8-62a4-4110-ba61-af94806c006f"
            }
          }
        ],
        "requestBody": {
          "description": "Parameters of a message to change.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Cancelscheduledmessagerequest"
              },
              "example": {
                "status": "cancelled"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "Message status updated successfully"
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          },
          "404": {
            "description": "Resource not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/404response"
                }
              }
            }
          }
        },
        "x-codeSamples": [
          {
            "lang": "C#",
            "label": "C#",
            "source": "string messageId = \"messageId2\";\nCancelScheduledMessageRequest body = new CancelScheduledMessageRequest();\nbody.Status = \"cancelled\";\n\ntry \n{\n    dynamic result = messages.CancelScheduledMessageAsync(messageId, body).Result;\n}\ncatch (APIException e){};"
          },
          {
            "lang": "Java",
            "label": "Java",
            "source": "String messageId = \"messageId2\";\nCancelScheduledMessageRequest body = new CancelScheduledMessageRequest();\nbody.setStatus(\"cancelled\");\n\nmessagesController.cancelScheduledMessageAsync(messageId, body, new APICallBack<DynamicResponse>() {\n    public void onSuccess(HttpContext context, DynamicResponse response) {\n        // TODO success callback handler\n    }\n    public void onFailure(HttpContext context, Throwable error) {\n        // TODO failure callback handler\n    }\n});"
          },
          {
            "lang": "JavaScript",
            "label": "JavaScript",
            "source": "let messageId = 'messageId2';\nlet body = new lib.CancelScheduledMessageRequest();\nbody.status = 'cancelled';\n\nconst promise = controller.cancelScheduledMessage(messageId, body);\npromise.then((response) => {\n    // this block will be executed on successful endpoint call\n    // `response` will be of type 'mixed'\n}, (err) => {\n    // this block will be executed on endpoint call failure\n    // `err` is an 'object' containing more information about the error\n});"
          },
          {
            "lang": "PHP",
            "label": "PHP",
            "source": "$messageId = 'messageId2';\n$body = new Models\\CancelScheduledMessageRequest;\n$body->status = 'cancelled';\n\n$result = $messagesController->cancelScheduledMessage($messageId, $body);"
          },
          {
            "lang": "Python",
            "label": "Python",
            "source": "message_id = 'messageId2'\nbody = CancelScheduledMessageRequest()\nbody.status = 'cancelled'\n\nresult = messages_controller.cancel_scheduled_message(message_id, body)"
          }
        ]
      }
    },
    "/v1/messages": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Messages"
        ],
        "summary": "Send messages",
        "description": "Submit one or more (up to 100 per request) SMS, MMS or text to voice\nmessages for delivery.\n\nThe most basic message has the following structure:\n\n```javascript\n\n{\n    \"messages\": [\n        {\n            \"content\": \"My first message!\",\n            \"destination_number\": \"+61491570156\"\n        }\n    ]\n}\n\n```\n\nMore advanced delivery features can be specified by setting the\nfollowing properties in a message:\n\n- ```callback_url``` A URL can be included with each message to which\nWebhooks will be pushed to via a HTTP POST request. Webhooks will be sent if and when the status of the message changes as it is processed (if the delivery report property of the request is set to ```true```) and when replies are received. Specifying a callback URL is optional.\n\n- ```content``` The content of the message. This can be a Unicode string, up to 5,000 characters long.\n  Message content is required.\n\n- ```delivery_report``` Delivery reports can be requested with each\nmessage. If delivery reports are requested, a webhook will be submitted to the ```callback_url``` property specified for the message (or to the webhooks)\n  specified for the account every time the status of the message changes as it is processed. The\n  current status of the message can also be retrieved via the Delivery Reports endpoint of the\n  Messages API. Delivery reports are optional and by default will not be requested.\n\n- ```destination_number``` The destination number the message should be\ndelivered to. This should be specified in E.164\n  international format. For information on E.164, please refer to http://en.wikipedia.org/wiki/E.164.\n  A destination number is required.  \n⚠️ IMDA TLS Compliance Notice: From 1 April 2026, all requests sending messages to Singapore (+65) numbers must use TLS 1.3 or higher. Requests using an older TLS version will be rejected with HTTP 422 Unprocessable Entity.\n\n- ```format``` The format specifies which format the message will be\nsent as, ```SMS``` (text message), ```MMS``` (multimedia message)\n  or ```TTS``` (text to speech). With ```TTS``` format, we will call the destination number and read out the\n  message using a computer generated voice. Specifying a format is optional, by default ```SMS``` will be used.\n\n- ```source_number_type``` If a source number is specified, the type of\nsource number may also be\n  specified. This is recommended when using a source address type that is not an internationally\n  formatted number, available options are ```INTERNATIONAL```, ```ALPHANUMERIC``` or ```SHORTCODE```. Specifying a\n  source number type is only valid when the ```source_number``` parameter is specified and is optional.\n  If a source number is specified and no source number type is specified, the source number type will be\n  inferred from the source number, however this may be inaccurate.\n\n- ```source_number```[optional]  Specify a source number to be used.  Refer to the section below for more information on source numbers.  \n⚠️ The number or sender ID must be registered to your account (from 1-Mar-2024).\n\n  #### Source number (sender ID)\n  \n  There are several options for the number or sender ID that will show as the source of an outbound message. Some things to note:\n    - If you do not specify a source number, the message will be sent with the default number for your account.\n      - The default may be a number you have purchased from us - such as a dedicated number, a 10-digit longcode or toll-free number (US/CA), or a shortcode. Log into the web portal to manage your numbers.\n      - If your account has multiple numbers, you can specify which source number to use in the request.\n      - If your account does not have a number, your message may be sent using our shared number pool (in certain countries only)\n    - `Alpha tag:` In some countries (AU, GB, some others), you may be able to send using an alpha tag - text that represents your brand of business.  Before using an alpha tag, you must register it in the Numbers section of the web portal.\n    - `Other numbers:` You may use numbers that you own as the source number, but you must register them in the Numbers section of the web portal to confirm you have a right to use the number.\n  If you need to register a large number of source numbers/sender IDs, consider using our [Source Address API](#tag/Source-Address)\n  \n  ⚠️ If you specify a source_number that is not registered to your account, the message may fail to send, or may be sent with an alternative number.\n\n- ```media``` The media is used to specify a list of URLs of the media file(s) that you are trying to send. \nSupported file formats include png, jpeg and gif. ```format``` parameter must be set to ```MMS``` for this to\nwork.\n\n- ```subject``` The subject field is used to denote subject of the MMS\nmessage and has a maximum size of 64 characters long. Specifying a\nsubject is optional.\n\n- ```scheduled``` A message can be scheduled for delivery in the future\nby setting the scheduled property.\n  The scheduled property expects a date time specified in ISO 8601 format. The scheduled time must be\n  provided in UTC and is optional. If no scheduled property is set, the message will be delivered immediately.\n\n- ```message_expiry_timestamp``` A message expiry timestamp can be\nprovided to specify the latest time\n  at which the message should be delivered. If the message cannot be delivered before the specified\n  message expiry timestamp elapses, the message will be discarded. Specifying a message expiry \n  timestamp is optional.\n\n- ```metadata``` Metadata can be included with the message which will\nthen be included with any delivery\n  reports or replies matched to the message. This can be used to create powerful two-way messaging\n  applications without having to store persistent data in the application. Up to 10 key / value metadata data\n  pairs can be specified in a message. Each key can be up to 100 characters long, and each value up to \n  256 characters long. Specifying metadata for a message is optional.\n\nThe response body of a successful POST request to the messages endpoint\nwill include a ```messages``` property which contains a list of all messages submitted. The list of\nmessages submitted will reflect the list of messages included in the request, but each message\nwill also contain two new properties, ```message_id``` and ```status```. The returned message ID\nwill be a 36 character UUID which can be used to check the status of the message via the Get Message\nStatus endpoint. The status of the message which reflect the status of the message at submission\ntime which will always be ```queued```. See the Delivery Reports section of this documentation for\nmore information on message statuses.\n\n*Note: when sending multiple messages in a request, all messages must be valid for the request \nto be successful. If any messages in the request are invalid, no messages will be sent.*\n",
        "operationId": "SendMessages",
        "parameters": [],
        "requestBody": {
          "description": "Request body.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Sendmessagesrequest"
              },
              "example": {
                "messages": [
                  {
                    "callback_url": "https://my.callback.url.com",
                    "content": "My first message",
                    "destination_number": "+61491570156",
                    "delivery_report": true,
                    "format": "SMS",
                    "message_expiry_timestamp": "2016-11-03T11:49:02.807Z",
                    "metadata": {
                      "key1": "value1",
                      "key2": "value2"
                    },
                    "scheduled": "2016-11-03T11:49:02.807Z",
                    "source_number": "+61491570157",
                    "source_number_type": "INTERNATIONAL"
                  },
                  {
                    "callback_url": "https://my.callback.url.com",
                    "content": "My second message",
                    "destination_number": "+61491570158",
                    "delivery_report": true,
                    "format": "MMS",
                    "subject": "This is an MMS message",
                    "media": [
                      "https://images.pexels.com/photos/1018350/pexels-photo-1018350.jpeg?cs=srgb&dl=architecture-buildings-city-1018350.jpg"
                    ],
                    "message_expiry_timestamp": "2016-11-03T11:49:02.807Z",
                    "metadata": {
                      "key1": "value1",
                      "key2": "value2"
                    },
                    "scheduled": "2016-11-03T11:49:02.807Z",
                    "source_number": "+61491570159",
                    "source_number_type": "INTERNATIONAL"
                  }
                ]
              }
            }
          },
          "required": true
        },
        "responses": {
          "202": {
            "description": "Messages were accepted for processing",
            "headers": {},
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Sendmessagesresponse"
                }
              }
            }
          },
          "400": {
            "description": "Unexpected error in API call. See HTTP response body for details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/400response"
                },
                "example": {
                  "message": "Something went wrong. Please try again later."
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/403response"
                }
              }
            }
          }
        },
        "x-codeSamples": [
          {
            "lang": "C#",
            "label": "C#",
            "source": "SendMessagesRequest body = new SendMessagesRequest();\nbody.Messages = new List<Message>();\n\nMessage body_messages_0 = new Message();\nbody_messages_0.CallbackUrl = \"https://my.callback.url.com\";\nbody_messages_0.Content = \"My first message\";\nbody_messages_0.DestinationNumber = \"+61491570156\";\nbody_messages_0.DeliveryReport = true;\nbody_messages_0.Format = Format.SMS;\nbody_messages_0.MessageExpiryTimestamp = DateTime.Parse(\"2016-11-03T11:49:02.807Z\");\nbody_messages_0.Metadata = APIHelper.JsonDeserialize<Object>(\"{\\\"key1\\\":\\\"value1\\\",\\\"key2\\\":\\\"value2\\\"}\");\nbody_messages_0.Scheduled = DateTime.Parse(\"2016-11-03T11:49:02.807Z\");\nbody_messages_0.SourceNumber = \"+61491570157\";\nbody_messages_0.SourceNumberType = SourceNumberType.INTERNATIONAL;\nbody.Messages.Add(body_messages_0);\n\nMessage body_messages_1 = new Message();\nbody_messages_1.CallbackUrl = \"https://my.callback.url.com\";\nbody_messages_1.Content = \"My second message\";\nbody_messages_1.DestinationNumber = \"+61491570158\";\nbody_messages_1.DeliveryReport = true;\nbody_messages_1.Format = Format.MMS;\nbody_messages_1.MessageExpiryTimestamp = DateTime.Parse(\"2016-11-03T11:49:02.807Z\");\nbody_messages_1.Metadata = APIHelper.JsonDeserialize<Object>(\"{\\\"key1\\\":\\\"value1\\\",\\\"key2\\\":\\\"value2\\\"}\");\nbody_messages_1.Scheduled = DateTime.Parse(\"2016-11-03T11:49:02.807Z\");\nbody_messages_1.SourceNumber = \"+61491570159\";\nbody_messages_1.SourceNumberType = SourceNumberType.INTERNATIONAL;\nbody_messages_1.Media = new List<string>();\nbody_messages_1.Media.Add(\"https://images.pexels.com/photos/1018350/pexels-photo-1018350.jpeg?cs=srgb&dl=architecture-buildings-city-1018350.jpg\");\nbody_messages_1.Subject = \"This is an MMS message\";\nbody.Messages.Add(body_messages_1);\n\n\ntry \n{\n    SendMessagesResponse result = messages.SendMessagesAsync(body).Result;\n}\ncatch (APIException e){};"
          },
          {
            "lang": "Java",
            "label": "Java",
            "source": "SendMessagesRequest body = new SendMessagesRequest();\nbody.setMessages(new LinkedList<Message>());\n\nMessage body_messages_0 = new Message();\nbody_messages_0.setCallbackUrl(\"https://my.callback.url.com\");\nbody_messages_0.setContent(\"My first message\");\nbody_messages_0.setDestinationNumber(\"+61491570156\");\nbody_messages_0.setDeliveryReport(true);\nbody_messages_0.setFormat(FormatEnum.SMS);\nbody_messages_0.setMessageExpiryTimestamp(new DateTime(\"2016-11-03T11:49:02.807Z\", DateTimeZone.UTC));\nbody_messages_0.setMetadata(com.messagemedia.messages.APIHelper.deserialize(\"{\\\"key1\\\":\\\"value1\\\",\\\"key2\\\":\\\"value2\\\"}\"));\nbody_messages_0.setScheduled(new DateTime(\"2016-11-03T11:49:02.807Z\", DateTimeZone.UTC));\nbody_messages_0.setSourceNumber(\"+61491570157\");\nbody_messages_0.setSourceNumberType(SourceNumberTypeEnum.INTERNATIONAL);\nbody.getMessages().add(body_messages_0);\n\nMessage body_messages_1 = new Message();\nbody_messages_1.setCallbackUrl(\"https://my.callback.url.com\");\nbody_messages_1.setContent(\"My second message\");\nbody_messages_1.setDestinationNumber(\"+61491570158\");\nbody_messages_1.setDeliveryReport(true);\nbody_messages_1.setFormat(FormatEnum.MMS);\nbody_messages_1.setMessageExpiryTimestamp(new DateTime(\"2016-11-03T11:49:02.807Z\", DateTimeZone.UTC));\nbody_messages_1.setMetadata(com.messagemedia.messages.APIHelper.deserialize(\"{\\\"key1\\\":\\\"value1\\\",\\\"key2\\\":\\\"value2\\\"}\"));\nbody_messages_1.setScheduled(new DateTime(\"2016-11-03T11:49:02.807Z\", DateTimeZone.UTC));\nbody_messages_1.setSourceNumber(\"+61491570159\");\nbody_messages_1.setSourceNumberType(SourceNumberTypeEnum.INTERNATIONAL);\nbody_messages_1.setMedia(new LinkedList<String>());\nbody_messages_1.getMedia().add(\"https://images.pexels.com/photos/1018350/pexels-photo-1018350.jpeg?cs=srgb&dl=architecture-buildings-city-1018350.jpg\");\nbody_messages_1.setSubject(\"This is an MMS message\");\nbody.getMessages().add(body_messages_1);\n\n\nmessagesController.sendMessagesAsync(body, new APICallBack<SendMessagesResponse>() {\n    public void onSuccess(HttpContext context, SendMessagesResponse response) {\n        // TODO success callback handler\n    }\n    public void onFailure(HttpContext context, Throwable error) {\n        // TODO failure callback handler\n    }\n});\n"
          },
          {
            "lang": "JavaScript",
            "label": "JavaScript",
            "source": "let body = new lib.SendMessagesRequest();\nbody.messages = [];\n\nbody.messages[0] = new lib.Message();\nbody.messages[0].callbackUrl = 'https://my.callback.url.com';\nbody.messages[0].content = 'My first message';\nbody.messages[0].destinationNumber = '+61491570156';\nbody.messages[0].deliveryReport = true;\nbody.messages[0].format = lib.FormatEnum.SMS;\nbody.messages[0].messageExpiryTimestamp = moment('2016-11-03T11:49:02.807Z').parseZone('2016-11-03T11:49:02.807Z');\nbody.messages[0].metadata = JSON.parse('{\"key1\":\"value1\",\"key2\":\"value2\"}');\nbody.messages[0].scheduled = moment('2016-11-03T11:49:02.807Z').parseZone('2016-11-03T11:49:02.807Z');\nbody.messages[0].sourceNumber = '+61491570157';\nbody.messages[0].sourceNumberType = lib.SourceNumberTypeEnum.INTERNATIONAL;\n\nbody.messages[1] = new lib.Message();\nbody.messages[1].callbackUrl = 'https://my.callback.url.com';\nbody.messages[1].content = 'My second message';\nbody.messages[1].destinationNumber = '+61491570158';\nbody.messages[1].deliveryReport = true;\nbody.messages[1].format = lib.FormatEnum.MMS;\nbody.messages[1].messageExpiryTimestamp = moment('2016-11-03T11:49:02.807Z').parseZone('2016-11-03T11:49:02.807Z');\nbody.messages[1].metadata = JSON.parse('{\"key1\":\"value1\",\"key2\":\"value2\"}');\nbody.messages[1].scheduled = moment('2016-11-03T11:49:02.807Z').parseZone('2016-11-03T11:49:02.807Z');\nbody.messages[1].sourceNumber = '+61491570159';\nbody.messages[1].sourceNumberType = lib.SourceNumberTypeEnum.INTERNATIONAL;\nbody.messages[1].media = ['https://images.pexels.com/photos/1018350/pexels-photo-1018350.jpeg?cs=srgb&dl=architecture-buildings-city-1018350.jpg'];\nbody.messages[1].subject = 'This is an MMS message';\n\n\nconst promise = controller.sendMessages(body);\npromise.then((response) => {\n    // this block will be executed on successful endpoint call\n    // `response` will be of type 'SendMessagesResponse'\n}, (err) => {\n    // this block will be executed on endpoint call failure\n    // `err` is an 'object' containing more information about the error\n});"
          },
          {
            "lang": "PHP",
            "label": "PHP",
            "source": "$body = new Models\\SendMessagesRequest;\n$body->messages = array();\n\n$body->messages[0] = new Models\\Message;\n$body->messages[0]->callbackUrl = 'https://my.callback.url.com';\n$body->messages[0]->content = 'My first message';\n$body->messages[0]->destinationNumber = '+61491570156';\n$body->messages[0]->deliveryReport = true;\n$body->messages[0]->format = Models\\FormatEnum::SMS;\n$body->messages[0]->messageExpiryTimestamp = DateTimeHelper::fromRfc3339DateTime('2016-11-03T11:49:02.807Z');\n$body->messages[0]->metadata = MessageMediaMessagesLib\\APIHelper::deserialize('{\"key1\":\"value1\",\"key2\":\"value2\"}');\n$body->messages[0]->scheduled = DateTimeHelper::fromRfc3339DateTime('2016-11-03T11:49:02.807Z');\n$body->messages[0]->sourceNumber = '+61491570157';\n$body->messages[0]->sourceNumberType = Models\\SourceNumberTypeEnum::INTERNATIONAL;\n\n$body->messages[1] = new Models\\Message;\n$body->messages[1]->callbackUrl = 'https://my.callback.url.com';\n$body->messages[1]->content = 'My second message';\n$body->messages[1]->destinationNumber = '+61491570158';\n$body->messages[1]->deliveryReport = true;\n$body->messages[1]->format = Models\\FormatEnum::MMS;\n$body->messages[1]->messageExpiryTimestamp = DateTimeHelper::fromRfc3339DateTime('2016-11-03T11:49:02.807Z');\n$body->messages[1]->metadata = MessageMediaMessagesLib\\APIHelper::deserialize('{\"key1\":\"value1\",\"key2\":\"value2\"}');\n$body->messages[1]->scheduled = DateTimeHelper::fromRfc3339DateTime('2016-11-03T11:49:02.807Z');\n$body->messages[1]->sourceNumber = '+61491570159';\n$body->messages[1]->sourceNumberType = Models\\SourceNumberTypeEnum::INTERNATIONAL;\n$body->messages[1]->media = array('https://images.pexels.com/photos/1018350/pexels-photo-1018350.jpeg?cs=srgb&dl=architecture-buildings-city-1018350.jpg');\n$body->messages[1]->subject = 'This is an MMS message';\n\n\n$result = $messagesController->sendMessages($body);"
          },
          {
            "lang": "Python",
            "label": "Python",
            "source": "body = SendMessagesRequest()\nbody.messages = []\n\nbody.messages.append(Message())\nbody.messages[0].callback_url = 'https://my.callback.url.com'\nbody.messages[0].content = 'My first message'\nbody.messages[0].destination_number = '+61491570156'\nbody.messages[0].delivery_report = True\nbody.messages[0].format = FormatEnum.SMS\nbody.messages[0].message_expiry_timestamp = dateutil.parser.parse('2016-11-03T11:49:02.807Z')\nbody.messages[0].metadata = jsonpickle.decode('{\"key1\":\"value1\",\"key2\":\"value2\"}')\nbody.messages[0].scheduled = dateutil.parser.parse('2016-11-03T11:49:02.807Z')\nbody.messages[0].source_number = '+61491570157'\nbody.messages[0].source_number_type = SourceNumberTypeEnum.INTERNATIONAL\n\nbody.messages.append(Message())\nbody.messages[1].callback_url = 'https://my.callback.url.com'\nbody.messages[1].content = 'My second message'\nbody.messages[1].destination_number = '+61491570158'\nbody.messages[1].delivery_report = True\nbody.messages[1].format = FormatEnum.MMS\nbody.messages[1].message_expiry_timestamp = dateutil.parser.parse('2016-11-03T11:49:02.807Z')\nbody.messages[1].metadata = jsonpickle.decode('{\"key1\":\"value1\",\"key2\":\"value2\"}')\nbody.messages[1].scheduled = dateutil.parser.parse('2016-11-03T11:49:02.807Z')\nbody.messages[1].source_number = '+61491570159'\nbody.messages[1].source_number_type = SourceNumberTypeEnum.INTERNATIONAL\nbody.messages[1].media = ['https://images.pexels.com/photos/1018350/pexels-photo-1018350.jpeg?cs=srgb&dl=architecture-buildings-city-1018350.jpg']\nbody.messages[1].subject = 'This is an MMS message'\n\n\nresult = messages_controller.send_messages(body)"
          }
        ]
      }
    },
    "/v1/messaging/numbers/sender_address/requests": {
      "post": {
        "security": [
          {
            "basic_auth": []
          },
          {
            "hmac_auth": []
          }
        ],
        "tags": [
          "Source Address"
        ],
        "summary": "Request a Sender Address",
        "description": "Submit a request to register a new Sender ID. When making a request to this endpoint, you will always need to specify ```sender_address_type``` and ```usage_type``` parameters. The following table shows the acceptable values and combinations for these parameters:\n  | Sender ID       | sender_address_type | usage_type     |\n  |---              |---                  |---             |\n  | Alpha tag       | `ALPHANUMERIC`      | `ALPHANUMERIC` |\n  | Personal number | `INTERNATIONAL`     | `OWN_NUMBER`   | \n\nThe other parameters required for your request will depend on the type of Sender ID you are registering.\n\n### Sender ID is an Alpha Tag\nThe following parameters are used when registering an alpha tag as a Sender ID:\n  - ```sender_address:``` **(Required)**. The alphanumeric string that you wish register as an alpha tag. This parameter is case insensitive. If this alpha tag already exists on your account, you will receive a conflict error message.\n  - ```destination_countries:``` **(Required)**. The countries that you wish to register the alpha tag for use in, in two-character ISO 3166 format. Currently AD, AI, AL, AS, AT, AW, BA, BB, BH, BW, CD, CH, CK, CY, DE, DJ, DK, DM, EE, ES, FI, FJ, FM, FO, FR, GB, GD, GG, GI, GL, GM, GQ, GR, GY, IL, IM, IS, JE, JM, JP, KI, KY, LA, LI, LS, LT, LU, LV, MC, ME, MH, MO, MR, MS, MT, MV, NC, NF, NL, NO, NR, NU, PF, PM, PT, SB, SC, SE, SH, SL, SM, ST, TC, TD, TO, VC, VG and WS are supported.\n  - ```sender_address_type:``` **(Required)**. For alpha tags this is always ALPHANUMERIC\n  - ```usage_type:``` **(Required)**. For alpha tags this is always ALPHANUMERIC\n  - ```label:``` **(Optional)**. A reference name for the sender ID to allow you to easily track it.\n  - ```reason:``` **(Required)**. This is a specifically formatted string made up of the following sub-items (all of which are required):\n\n    - `useCase:` one of the following:\n      - `SOLE_TRADER_NAME`\n      - `COMPANY_NAME`\n      - `PARTNERSHIP_NAME`\n      - `REGISTERED_TRUST_NAME`\n      - `CO_OPERATIVE_NAME`\n      - `INDIGENOUS_CORPORATION_NAME`\n      - `REGISTERED_ORGANISATION_NAME`\n      - `PERSONAL_NAME`\n      - `AUSTRALIAN_TRADEMARK`\n      - `INTERNATIONAL_TRADEMARK`\n      - `AUSTRALIAN_GOVERNMENT_AGENCY_OR_ENTITY`\n      - `FOREIGN_GOVERNMENT_AGENCY_OR_ENTITY`\n      - `PRODUCT_OR_SERVICE_NAME`\n      - `ACRONYM_INITIALISM`\n      - `CONTRACTION_OF_NAME`\n      - `OTHER`\n    - `description:` A description used if OTHER was selected as the use case. Limited to 200 characters.\n\n    - `email:` The preferred contact email for our approval team when additional details are required.\n\n    - `australianGovernmentAgencyOrEntityName:` The name of your organisation.\n\n    - `abn:` Your organisation’s Australian Business Number\n\n    - `statement:` A legal declaration\n      - If applying for your own business: \"We are authorized to use the Sender ID with a valid use case.\"\n      - If applying on behalf of a third-party entity: \"We are authorized to use the Sender ID on behalf of [full entity name of sender] with a valid use case.\"\n\nThe reason parameter must contain all the above items. A well formatted reason looks like the following:\n  - \"reason\": \"{\\n&nbsp;&nbsp;\\\\\"useCase\\\\\":\\\\\"AUSTRALIAN_GOVERNMENT_AGENCY_OR_ENTITY\\\\\",\\n&nbsp;&nbsp;\\\\\"description\\\\\":\\\\\"bal bla\\\\\",\\n&nbsp;&nbsp;\\\\\"email\\\\\":\\\\\"example@email.com\\\\\",\\n&nbsp;&nbsp;\\\\\"australianGovernmentAgencyOrEntityName\\\\\":\\\\\"bla bla\\\\\",\\n&nbsp;&nbsp;\\\\\"statement\\\\\":\\\\\"We are authorised to use the Sender ID on behalf of [full entity name of sender] with a valid use case.\\\\\"\\n}\\n\"\n\n### Sender ID is a Personal Number\nThe following parameters are used when registering a personal mobile phone number as a Sender ID: \n\n  - ```sender_address:``` **(Required)**. The phone number that you wish register as a personal number. This number must be in E.164. If this number is already registered to an account, you will receive a conflict error message. \n\n  - ```destination_countries:``` **(Required)**. The country of the number that you wish to register, in two-character ISO 3166 format. Refer to the **Types of Sender ID** section for a list of currently supported countries. \n\n  - ```sender_address_type:``` **(Required)**. For personal numbers this is always INTERNATIONAL \n\n  - ```usage_type:``` **(Required)**. For personal numbers this is a
[...]
